/////////////////////////////////////////////////////////////////////////////
// Name:        Do178Builder.cpp
// Author:      Ron Burkey
// Purpose:     This is sort of the top-level source file for the 
//              Do178Builder application.  It contains the code for the 
//              Do178BuilderApp and Do178BuilderFrame classes.
// Mods:        09/21/01 RSB    Created.  This file was created initially 
//                              by the wizard of the wxDesigner program,
//                              and is modified somewhat every time I use 
//                              wxDesigner to tweak the user interface. 
//                              In fact, wxDesigner puts all of the code
//                              it generates here, tending to make this file
//                              very large and complex.  What I've done,
//                              therefore, is to leave the code for the
//                              Do178BuilderApp and Do178BuilderFrame
//                              classes here, as well as all event tables.
//                              But each significant class, such as
//                              XmlEditorDialogClass is given its own source
//                              file (like XmlEditorDialogClass.cpp),
//                              and all of the code for those classes 
//                              (except event tables) is moved to those files.
//                              The program comments in this file beginning
//                              "WDR:" are used by wxDesigner, and should
//                              not be modified.
//              10/21/01 RSB    ... still under continual adjustment ...
//              02/17/02 RSB    Adjusted the splash screen, etc.
//              Added automatic loading of XML from command
//              line.
//      02/18/02 RSB    Added OnSize to the XmlEditorDialogClass.

/*
  Copyright 2001,2002 Ronald S. Burkey

  This file is part of Do178Builder.

  Do178Builder is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Do178Builder is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Do178Builder; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/////////////////////////////////////////////////////////////////////////////

#ifdef __GNUG__
#pragma implementation "Do178Builder.cpp"
#endif

// For compilers that support precompilation
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

// Include private headers
#include "Do178Builder.h"
#include "Do178Builder_wdr.h"

#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>

// Here are some things needed only in Win32
#ifndef NAME_MAX
#define NAME_MAX 512
#endif
#ifdef __WINDOWS__
#define MKDIR(x) mkdir(x)
#else
#define MKDIR(x) mkdir(x,0750)
#endif

bool HintEditable = FALSE;
int DatasetChanged = 0;
wxString rFilename, nFilename;
static char CurrentDirectory[NAME_MAX + 1] = ".";
static char HomeDirectory[NAME_MAX + 1] = ".";
static struct XmlStruct Xml = { NULL }, TemplateXml;
int CopyrightSplash = 1;
static char s[1024];        // A dummy array used several places.

// WDR: class implementations

//----------------------------------------------------------------------------
// SearchBoxClass
//----------------------------------------------------------------------------

// WDR: event table for SearchBoxClass

BEGIN_EVENT_TABLE (SearchBoxClass, wxDialog)
EVT_CHECKBOX (ID_SEARCHTITLES, SearchBoxClass::CheckSearchTitles)
EVT_CHECKBOX (ID_SEARCHDESCRIPTIVE, SearchBoxClass::CheckSearchText)
EVT_CHECKBOX (ID_SEARCHHINT, SearchBoxClass::CheckSearchHints)
EVT_BUTTON (ID_SEARCHNOW, SearchBoxClass::ClickSearchButton)
EVT_BUTTON (ID_SEARCHCANCEL, SearchBoxClass::ClickSearchCancel)
EVT_CHECKBOX (ID_SEARCHALL, SearchBoxClass::CheckAllDocs)
EVT_CHECKBOX (ID_SEARCHPSAC, SearchBoxClass::CheckSearchPsac)
EVT_CHECKBOX (ID_SEARCHSDP, SearchBoxClass::CheckSearchSdp)
EVT_CHECKBOX (ID_SEARCHSVP, SearchBoxClass::CheckSearchSvp)
EVT_CHECKBOX (ID_SEARCHSCMP, SearchBoxClass::CheckSearchScmp)
EVT_CHECKBOX (ID_SEARCHSQAP, SearchBoxClass::CheckSearchSqap)
EVT_CHECKBOX (ID_SEARCHSRS, SearchBoxClass::CheckSearchSrs)
EVT_CHECKBOX (ID_SEARCHSDS, SearchBoxClass::CheckSearchSds)
EVT_CHECKBOX (ID_SEARCHSCS, SearchBoxClass::CheckSearchScs)
EVT_CHECKBOX (ID_SEARCHSRD, SearchBoxClass::CheckSearchSrd)
EVT_CHECKBOX (ID_SEARCHSDD, SearchBoxClass::CheckSearchSdd)
EVT_CHECKBOX (ID_SEARCHSVCP, SearchBoxClass::CheckSearchSvcp)
EVT_CHECKBOX (ID_SEARCHSECI, SearchBoxClass::CheckSearchSeci)
EVT_CHECKBOX (ID_SEARCHSCI, SearchBoxClass::CheckSearchSci)
EVT_CHECKBOX (ID_SEARCHSAS, SearchBoxClass::CheckSearchSas)
END_EVENT_TABLE ();

// WDR: handler implementations for SearchBoxClass
// (This is the position where wxDesigner inserts new code,
// but to keep the source files manageable, I move it later.
// Refer to SearchBoxClass.cpp for the actual code.)


//----------------------------------------------------------------------------
// ProjectOptionEditorClass
//----------------------------------------------------------------------------

// WDR: event table for ProjectOptionEditorClass

BEGIN_EVENT_TABLE (ProjectOptionEditorClass, wxDialog)
EVT_BUTTON (ID_PROJECTOPTIONSOK, ProjectOptionEditorClass::OkProjectOptions)
EVT_BUTTON (ID_PROJECTOPTIONSCANCEL,
        ProjectOptionEditorClass::CancelProjectOptions)
END_EVENT_TABLE ();

ProjectOptionEditorClass::ProjectOptionEditorClass (wxWindow * parent,
                            wxWindowID id,
                            const wxString & title,
                            const wxPoint &
                            position,
                            const wxSize & size,
                            long style):
wxDialog (parent, id, title, position, size, style)
{
  ProjectOptionEditor (this, TRUE);
}


// WDR: handler implementations for ProjectOptionEditorClass.

void
ProjectOptionEditorClass::CancelProjectOptions (wxCommandEvent & event)
{
  EndModal (0);
}

void
ProjectOptionEditorClass::OkProjectOptions (wxCommandEvent & event)
{
  EndModal (0);
}


//----------------------------------------------------------------------------
// XmlEditorDialogClass
//----------------------------------------------------------------------------

// WDR: event table for XmlEditorDialogClass

BEGIN_EVENT_TABLE (XmlEditorDialogClass, wxDialog)
EVT_TREE_SEL_CHANGED (ID_XMLEDITOR, XmlEditorDialogClass::ClickTree)
EVT_CHECKBOX (ID_PSAC, XmlEditorDialogClass::PsacClick)
EVT_CHECKBOX (ID_SDP, XmlEditorDialogClass::SdpClick)
EVT_CHECKBOX (ID_SVP, XmlEditorDialogClass::SvpClick)
EVT_CHECKBOX (ID_SCMP, XmlEditorDialogClass::ScmpClick)
EVT_CHECKBOX (ID_SQAP, XmlEditorDialogClass::SqapClick)
EVT_CHECKBOX (ID_SRS, XmlEditorDialogClass::SrsClick)
EVT_CHECKBOX (ID_SDS, XmlEditorDialogClass::SdsClick)
EVT_CHECKBOX (ID_SCS, XmlEditorDialogClass::ScsClick)
EVT_CHECKBOX (ID_SRD, XmlEditorDialogClass::SrdClick)
EVT_CHECKBOX (ID_DD, XmlEditorDialogClass::DdClick)
EVT_CHECKBOX (ID_SVCP, XmlEditorDialogClass::SvcpClick)
EVT_CHECKBOX (ID_SECI, XmlEditorDialogClass::SeciClick)
EVT_CHECKBOX (ID_SCI, XmlEditorDialogClass::SciClick)
EVT_CHECKBOX (ID_SAS, XmlEditorDialogClass::SasClick)
EVT_BUTTON (ID_SATA, XmlEditorDialogClass::ClickSatA)
EVT_BUTTON (ID_SATB, XmlEditorDialogClass::ClickSatB)
EVT_BUTTON (ID_SATC, XmlEditorDialogClass::ClickSatC)
EVT_BUTTON (ID_SATD, XmlEditorDialogClass::ClickSatD)
EVT_BUTTON (ID_SATE, XmlEditorDialogClass::ClickSatE)
EVT_BUTTON (ID_CCA, XmlEditorDialogClass::ClickCcA)
EVT_BUTTON (ID_CCB, XmlEditorDialogClass::ClickCcB)
EVT_BUTTON (ID_CCC, XmlEditorDialogClass::ClickCcC)
EVT_BUTTON (ID_CCD, XmlEditorDialogClass::ClickCcD)
EVT_BUTTON (ID_CCE, XmlEditorDialogClass::ClickCcE)
EVT_BUTTON (ID_ADD_ITEM, XmlEditorDialogClass::AddItem)
EVT_BUTTON (ID_SUBITEM, XmlEditorDialogClass::AddSubItem)
EVT_BUTTON (ID_DELETE_ITEM, XmlEditorDialogClass::DeleteItem)
EVT_BUTTON (ID_SAVEBUTTON, XmlEditorDialogClass::SaveButton)
EVT_CHECKBOX (ID_SVR, XmlEditorDialogClass::SvrClick)
EVT_CHECKBOX (ID_SCMR, XmlEditorDialogClass::ScmrClick)
EVT_CHECKBOX (ID_SQAR, XmlEditorDialogClass::SqarClick)
EVT_BUTTON (ID_FINDBUTTON, XmlEditorDialogClass::FindButton)
EVT_BUTTON (ID_FINDAGAINBUTTON, XmlEditorDialogClass::FindAgainButton)
EVT_BUTTON (ID_MARKUPBUTTON, XmlEditorDialogClass::MarkupButtonClick)
EVT_RADIOBUTTON (ID_NOVICEBUTTON, XmlEditorDialogClass::NoviceCheck)
EVT_RADIOBUTTON (ID_EXPERTBUTTON, XmlEditorDialogClass::ExpertCheck)
EVT_CLOSE (XmlEditorDialogClass::OnClose) 
//EVT_SIZE (XmlEditorDialogClass::OnSize) 
END_EVENT_TABLE ();


// WDR: handler implementations for XmlEditorDialogClass.

// (This is the position where wxDesigner inserts new code,
// but to keep the source files manageable, I move it later.
// Refer to XmlEditorDialogClass.cpp for the actual code.)


//------------------------------------------------------------------------------
// Do178BuilderFrame
//------------------------------------------------------------------------------

// WDR: event table for Do178BuilderFrame

BEGIN_EVENT_TABLE (Do178BuilderFrame, wxFrame)
EVT_MENU (ID_ABOUT, Do178BuilderFrame::OnAbout)
EVT_MENU (ID_QUIT, Do178BuilderFrame::OnQuit)
EVT_CLOSE (Do178BuilderFrame::OnCloseWindow)
EVT_MENU (ID_OPEN, Do178BuilderFrame::Open)
EVT_MENU (ID_PROJECTOPTIONS, Do178BuilderFrame::ProjectOptions)
EVT_MENU (ID_EDIT, Do178BuilderFrame::EditDataset)
EVT_MENU (ID_EDITABLEHINTS, Do178BuilderFrame::HintEditCheck)
EVT_MENU (ID_CLOSE, Do178BuilderFrame::CloseFile)
EVT_MENU (ID_SAVE, Do178BuilderFrame::SaveFile)
EVT_MENU (ID_BUILDDOCUMENTS, Do178BuilderFrame::BuildDocuments)
EVT_MENU (ID_SAVEAS, Do178BuilderFrame::SaveFileAs) END_EVENT_TABLE ();


Do178BuilderFrame::Do178BuilderFrame (wxWindow * parent,
                      wxWindowID id,
                      const wxString &
                      title,
                      const wxPoint &
                      position,
                      const wxSize & size, long style):
wxFrame (parent, id, title, position, size, style)
{
/*
  if (getenv ("HOME") == NULL)
    getcwd (HomeDirectory, sizeof (HomeDirectory));
  else
    strcpy (HomeDirectory, getenv ("HOME"));
*/

  Centre ();
  Maximize ();

  CreateMyMenuBar ();

  CreateMyToolBar ();

  CreateStatusBar (1);
  SetStatusText ("Welcome to DO-178 Builder (build " __DATE__ ")");

  // Splash screen.  Oddly, the wxFatalError doesn't actually show up.
  // But I don't care about that, since it's really all I wanted anyhow.
  if (CopyrightSplash && wxYES !=
      wxMessageBox ("Do178Builder version " __DATE__
            ", Copyright 2001,2002 Ronald S. Burkey.\n"
            "Do178Builder comes with ABSOLUTELY NO WARRANTY; for details\n"
            "refer to the Help menu.  This is free software, and you are welcome\n"
            "to redistribute it under certain conditions; refer to the Help menu\n"
            "for details.  Indicate below if you agree.",
            "Copyright advisory",
            wxYES_NO | wxCENTRE | wxICON_INFORMATION))
    wxFatalError ("Sorry you feel that way!\nGoodbye until next time.",
          "Abort");

  // insert main window here
}

void
Do178BuilderFrame::LoadXmlToEditor (struct XmlStruct *Xml,
                    XmlEditorDialogClass & dialog,
                    wxTreeItemId Root)
{
  int WasRoot = 0;
  wxTreeItemId NewItem;
  dialog.LastSelected = -1;
  if (Root == (wxTreeItemId) - 1)
    {
      WasRoot = 1;
      Root = dialog.ItemTree->AddRoot (Xml->Name);
      Xml->Id = Root;
      Xml = Xml->Children;
    }
  for (; Xml != NULL; Xml = Xml->Next)
    {
      NewItem = dialog.ItemTree->AppendItem (Root, Xml->Name);
      dialog.ItemTree->SetItemTextColour (NewItem, *Xml->Color);
      Xml->Id = NewItem;
      if (Xml->Children != NULL)
    LoadXmlToEditor (Xml->Children, dialog, NewItem);
    }
  if (WasRoot)
    dialog.ItemTree->Expand (Root);
}

void
Do178BuilderFrame::CreateMyMenuBar ()
{
#ifdef __WXMAC__
  wxApp::s_macAboutMenuItemId = ID_ABOUT;
#endif

  SetMenuBar (MyMenuBarFunc ());
}

void
Do178BuilderFrame::CreateMyToolBar ()
{
  wxToolBar *tb = CreateToolBar (wxTB_HORIZONTAL | wxNO_BORDER);

  // tb->AddTool( ID_QUIT, wxBitmap( xxxx_xpm ), "Quit" );

  tb->Realize ();
}

// WDR: handler implementations for Do178BuilderFrame

void
Do178BuilderFrame::BuildDocuments (wxMenuEvent & event)
{
  //char s[1024]; 
  char *ss;
  wxString OutputDirectory, SourceDir;
  struct stat StatBuf;
  int i, RetVal;

  // Figure out the name of the output directory.  We do this
  // by taking the name of the source file and creating a 
  // subdirectory with the same name (but without the extension
  // ".documents" instead of ".xml".
  strcpy (s, rFilename);
  ss = strstr (s, ".xml");
  if (ss == NULL || 0 != strcmp (ss, ".xml"))
    {
      sprintf (s, "Your dataset filename does not end in \".xml\".");
      goto ErrorExit;
    }
  strcpy (ss, ".documents");
  OutputDirectory = s;

  // Create the output directory, if necessary.
  i = stat (OutputDirectory, &StatBuf);
  if (i != 0)
    {
      // Output directory doesn't exist (or its name is bollixed.
      if (0 != MKDIR (OutputDirectory))
    {
      sprintf (s, "Cannot create the ouput directory\n\"%s\"",
           OutputDirectory.GetData ());
      goto ErrorExit;
    }
    }
  else if ((StatBuf.st_mode & S_IFDIR) == 0)
    {
      // The output directory exists -- except that it ISN'T a directory.
      sprintf (s, "The name we want to use for the output directory\n"
           "is not available:\n%s", OutputDirectory.GetData ());
      goto ErrorExit;
    }
  else
    {
      // The output directory really exists.
      sprintf (s, "The output directory already exists:\n"
           "%s\nIs it okay to overwrite the existing contents?",
           OutputDirectory.GetData ());
      if (wxYES !=
      wxMessageBox (s, "Advisory", wxYES_NO | wxCENTRE | wxICON_WARNING))
    {
      sprintf (s, "Aborted by user.");
      goto ErrorExit;
    }
    }
  OutputDirectory = OutputDirectory + "/";

  // Create the documents themselves.  
  SetStatusText ("Building DO-178B documents -- please wait ...");
  RetVal = XmlToSgml (&Xml, OutputDirectory);
  if (RetVal == 0)
    {
      i = strlen (OutputDirectory);
      if (i < 30)
    i = (40 - i) / 2;
      else
    i = 0;
      sprintf (s, "The DO-178B documents have been created, in\n"
           "%*s%s.\n"
           "They are DocBook files with names like PSAC.sgml,\n"
           "SDP.sgml, SVP.sgml, SCMP.sgml, and so on.",
           i, "", OutputDirectory.GetData ());
      wxMessageBox (s, "Status", wxCENTRE | wxOK | wxICON_INFORMATION);
      SetStatusText ("Document-build completed.");
    }
  else
    {
      sprintf (s,
           "Could not create documents.\nError code #%d on document #%d",
           RetVal & 0xff, (RetVal >> 8) & 0xff);
    ErrorExit:
      wxMessageBox (s, "Error", wxCENTRE | wxOK | wxICON_ERROR);
      SetStatusText ("Errors occurred in the document-build.");
    }
}

void
Do178BuilderFrame::SaveFileAs (wxMenuEvent & event)
{
  wxString NewFilename;
  NewFilename =
    wxFileSelector ("Save dataset under new filename", ".", rFilename, "xml",
            "*.xml", wxSAVE | wxOVERWRITE_PROMPT);
  if (NewFilename)
    {
      SetStatusText (NewFilename);
      rFilename = NewFilename;
      SaveFile (event);
    }
}

void
Do178BuilderFrame::SaveFile (wxMenuEvent & event)
{
  if (SaveXmlFile (rFilename, &Xml))
    wxMessageBox ("Could not save the file.", "Error",
          wxCENTRE | wxOK | wxICON_ERROR);
  else
    DatasetChanged = 0;
}

void
Do178BuilderFrame::CloseFile (wxMenuEvent & event)
{
  if (UnsavedCancel ())
    return;
  FileIsOpen = 0;
}

void
Do178BuilderFrame::HintEditCheck (wxMenuEvent & event)
{
  //HintEditable = !HintEditable;
  //wxObject *Object = event.GetEventObject ();
  wxMenuBar *MenuBar = GetMenuBar ();
  wxMenuItem *MenuItem = MenuBar->FindItem (ID_EDITABLEHINTS);
  HintEditable = MenuItem->IsChecked ();
  if (HintEditable && wxYES != wxMessageBox
      ("Framework-editing mode is an administrative function,\n"
       "not needed in a typical design project.  It can\n"
       "introduce incompatibilities with existing project-\n"
       "datasets, if while in framework-editing mode you add,\n"
       "delete, or rename data items.  On the other hand,\n"
       "it is perfectly safe to use it for editing HINTS.\n"
       "Are you sure you want to proceed?",
       "Compatibility danger!", wxYES_NO | wxCENTRE | wxICON_EXCLAMATION))
    {
      HintEditable = FALSE;
      MenuItem->Check (FALSE);
    }
}

void
Do178BuilderFrame::EditDataset (wxMenuEvent & event)
{
  if (!FileIsOpen)
    {
      wxMessageBox
    ("There is no project-dataset file loaded at the moment.\n"
     "You will have to open a file before editing it.\n",
     "Sorry!", wxOK | wxCENTRE | wxICON_EXCLAMATION);
      return;
    }
  XmlEditorDialogClass dialog (this, -1, "Documentation dataset editor",
                   wxDefaultPosition, wxDefaultSize,
                   wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
  dialog.RootXml = &Xml;
  dialog.Template = &TemplateXml;
  // Now load the actual project data into the dialog.
  LoadXmlToEditor (&Xml, dialog, -1);
  dialog.ItemTree->SelectItem (Xml.Id);
  wxTreeEvent DummyEvent;
  dialog.ClickTreeBypass = 1;
  dialog.ClickTree (DummyEvent);
  dialog.Center ();
  dialog.ShowModal ();
}

void
Do178BuilderFrame::ProjectOptions (wxMenuEvent & event)
{
  ProjectOptionEditorClass dialog (this, -1, "Project options");
  dialog.Center ();
  dialog.ShowModal ();
}

int
Do178BuilderFrame::UnsavedCancel (void)
{
  if (DatasetChanged)
    switch (wxMessageBox
        ("The dataset has changed.  These changes will be lost.\n"
         "Save the dataset before continuing?", "Confirm",
         wxYES_NO | wxCANCEL | wxCENTRE | wxICON_QUESTION))
      {
      case wxYES:
    if (SaveXmlFile (rFilename, &Xml))
      {
        wxMessageBox ("Cannot save the file.\nPerhaps the disk is full.",
              "Error", wxCENTRE | wxOK | wxICON_ERROR);
        return (1);
      }
    break;
      case wxNO:
    break;
      case wxCANCEL:
      default:
    return (1);
      }
  DatasetChanged = 0;
  return (0);
}

void
Do178BuilderFrame::Open (wxMenuEvent & event)
{
  int ReturnValue;
  //char s[128];
  if (UnsavedCancel ())
    return;
  FileIsOpen = 0;
  rFilename =
    wxFileSelector ("Open existing dataset", CurrentDirectory, "", "xml",
            "*.xml", wxOPEN | wxFILE_MUST_EXIST);
  if (rFilename)
    if (0 == (ReturnValue = LoadXmlFile (rFilename, &Xml)))
      {
    SetStatusText (rFilename);
    FileIsOpen = 1;
    EditDataset (event);
      }
    else
      {
    sprintf (s, "Could not load the file.\nError code #%d", ReturnValue);
    wxMessageBox (s, "Error", wxCENTRE | wxOK | wxICON_ERROR);
      }
}

void
Do178BuilderFrame::OpenTemplate (void)
{
  int ReturnValue;
  //char s[1024];
  sprintf (s, "%s/.template.xml", HomeDirectory);
/*  
  char *ss, *sss;
  strcpy (s, argv[0]);
  for (sss = NULL, ss = s; *ss; ss++)
    if (*ss == '/')
      sss = ss;
  if (sss != NULL)
    {    
      *sss = '\0';
      strcpy (HomeDirectory, s);
      strcat (s, "/.template.xml");    
    }
  else
    strcpy (s, ".template.xml");  
*/
  ReturnValue = LoadXmlFile (s, &TemplateXml);
  if (0 == ReturnValue)
    return;
  rFilename =
    wxFileSelector ("Please locate hidden file .template.xml",
            HomeDirectory, "", "xml", ".template.xml",
            wxOPEN | wxFILE_MUST_EXIST);
  if (0 == (ReturnValue = LoadXmlFile (rFilename, &TemplateXml)))
    return;
  else
    {
      sprintf (s, "Could not load .template.xml.\nError code #%d",
           ReturnValue);
      wxMessageBox (s, "Fatal error", wxCENTRE | wxOK | wxICON_ERROR);
      close (TRUE);
    }
}

void
Do178BuilderFrame::OnAbout (wxCommandEvent & event)
{
  wxMessageDialog dialog (this,
              "Welcome to DO-178 Builder (build " __DATE__
              ")\nCopyright 2001,2002 Ron Burkey",
              "About DO-178 Builder", wxOK | wxICON_INFORMATION);
  dialog.Center ();
  dialog.ShowModal ();
}

void
Do178BuilderFrame::OnQuit (wxCommandEvent & event)
{
  if (UnsavedCancel ())
    return;
  Close (TRUE);
}

void
Do178BuilderFrame::OnCloseWindow (wxCloseEvent & event)
{
  // if ! saved changes -> return
  if (UnsavedCancel ())
    return;

  Destroy ();
}

//------------------------------------------------------------------------------
// Do178BuilderApp
//------------------------------------------------------------------------------

IMPLEMENT_APP (Do178BuilderApp) Do178BuilderApp::Do178BuilderApp ()
{
}

bool
Do178BuilderApp::OnInit ()
{
  int FileIsOpen = 0;

  // We figure out the home directory by examining the path of the program
  // name.  If none, we use the current working directory.
  //char s[1024]; 
  char *ss, *sss;
  strcpy (s, argv[0]);
  for (sss = NULL, ss = s; *ss; ss++)
    if (*ss == '/')
      sss = ss;
  if (sss == NULL)
    {
      getcwd (s, sizeof (s));
      ss = s + strlen (s) - 1;
      if (*ss == '/')
    *ss = '\0';
    }
  else
    *sss = '\0';
  strcpy (HomeDirectory, s);

  // Examine the command-line arguments.  
  int i;
  for (i = 1; i < argc; i++)
    {
      if (0 == strcasecmp (argv[i], "-h")
      || 0 == strcasecmp (argv[i], "--help")
      || 0 == strcasecmp (argv[i], "-?"))
    {
      printf ("---------------------------------------");
      printf ("---------------------------------------\n");
      printf ("Do178Builder, build %s\n", __DATE__);
      printf ("Copyright 2001,2002 by Ronald S. Burkey.\n");
      printf ("Licensed under the GPL.\n");
      printf ("\n");
      printf ("Do178Builder helps incorporate DO-178B ");
      printf ("into the software-development effort.\n");
      printf ("Specifically, it creates DO-178B documents ");
      printf ("for aviation-certification purposes.\n");
      printf ("\n");
      printf ("USAGE:\tDo178Builder [OPTIONS] [XMLfile]\n");
      printf ("\n");
      printf ("OPTIONS:\n");
      printf ("\t-h           Display this help information.\n");
      printf ("\t-p=dirname   Specify your project directory.\n");
      printf ("\t-c           Eliminate the copyright splashscreen\n");
      printf ("\n");
      printf
        ("If the optional XMLfile is specified, it will be loaded.\n");
      printf ("---------------------------------------");
      printf ("---------------------------------------\n");
      exit (0);
    }
      else if (0 == strncasecmp (argv[i], "-p=", 3))
    strcpy (CurrentDirectory, &argv[i][3]);
      else if (0 == strcasecmp (argv[i], "-c"))
    CopyrightSplash = 0;
      else if (!FileIsOpen)
    {
      if (0 == LoadXmlFile (argv[i], &Xml))
        {
          nFilename = argv[i];
          FileIsOpen = 1;
        }
    }
    }

  // Okay, continue with normal setup.
  Do178BuilderFrame *frame =
    new Do178BuilderFrame (NULL, -1, "DO-178 Builder", wxPoint (20, 20),
               wxSize (500, 340));
  frame->OpenTemplate ();
  frame->Show (TRUE);

  if (FileIsOpen)
    {
      rFilename = nFilename;
      frame->FileIsOpen = FileIsOpen;
      frame->SetStatusText (nFilename);
      /*
        At this point, we presumably need to use wxPostEvent to set a
    pending menu click on the ID_EDIT menu item that will later 
    activate the frame->EditDataset function.  This function
    cannot be called directly at this point.  Unfortunately,
    I don't yet know how to make that happen.
      */
    }

  return TRUE;
}

int
Do178BuilderApp::OnExit ()
{
  return 0;
}
